/*
 *= RexUsb61mk2lib.h ===========================================================
 *
 * Copyright(C) 2013 RATOC Systems,Inc.
 *
 * Description: Global defines for REX-USB61MK2 
 *
 * Compiler: Tested with Visual C2008
 *
 * Revision: 1.00 (last modified: 2015-03-02)
 *
 *==============================================================================
 */

#ifndef __USB61MK2_DEFINE__
#define __USB61MK2_DEFINE__

//
// Window Message
//
#define WM_61MK2	WM_APP+61
// Interruptv
#define RS_INT_DIO			0x00010000
#define RS_INT_PAUSE		0x00020000
#define RS_INT_START		0x00040000
#define RS_INT_END			0x00080000
#define RS_INT_EP1_EMPTY	0x00100000
#define RS_INT_EP1_FULL		0x00200000
#define RS_INT_EP2_FULL		0x00400000
#define RS_INT_TICK_OVER	0x00800000

//
// led control
//
// LED (usb61mk2_led_control Ŏw肷)
#define RS_LEDCTRL_OFF					0x00	// FWŐĊJ
#define RS_LEDCTRL_ON						0x80	// FWŐ~
#define RS_LEDCTRL_LED0_ON			0x01	// LED0_
#define RS_LEDCTRL_LED1_ON			0x02	// LED1_
#define RS_LEDCTRL_BOTH_ON			0x03	// LED0/LED1_

//
// power control
//
// d (usb61mk2_power_control Ŏw肷)
#define RS_PWRCTRL_OFF			0x00	// dsȂ
#define RS_PWRCTRL_ON				0x01	// ds
#define RS_PWRCTRL_1_8V			0x02	// o͓d 1.8V
#define RS_PWRCTRL_2_5V			0x04	// o͓d 2.5V
#define RS_PWRCTRL_3_3V			0x06	// o͓d 3.3V
#define RS_PWRCTRL_5_0V			0x08	// o͓d 5.0V

//
// device mode
//
// foCXݒ (usb61mk2_mode_change Ŏw肷)
#define RS_DEVMODE_SPI			0x00	// SPI
#define RS_DEVMODE_I2C			0x01	// I2C
//                   (usb61mk2_set_mode Ŏw肷)
#define RS_DEVMODE_SEQ			0x00	// s
#define RS_DEVMODE_PACK			0x01	// ꊇs

//
// hardware infomation
//
// foCX (_RS_HARDWARE_INFO \)
typedef struct _RS_HARDWARE_INFO {
	UCHAR	DeviceMode;			// SPI/I2CfoCX
	UCHAR	PowerCtrl;			// dd
	WORD	TargetPower;		// ^[Qbgdd
	WORD	Interval;			// MԊu
	LONG	Frequency;			// gݒ
	UCHAR	Sign1;				// g̐ݒl
	UCHAR	Sign2;				// g̐ݒl
	UCHAR	Sign3;				// g̐ݒl
	UCHAR	Adjust1;			// g̐ݒl
	UCHAR	Adjust2;			// g̐ݒl
	UCHAR	Adjust3;			// g̐ݒl
} RS_HARDWARE_INFO, *PRS_HARDWARE_INFO;
// n[hEFA (usb61mk2_get_hw_info ŕԂl)
#define RS_HARDWARE_SPI			0x00	// SPI (_RS_HARDWARE_INFO  DeviceMode ɃZbgl)
#define RS_HARDWARE_I2C			0x01	// I2C (_RS_HARDWARE_INFO  DeviceMode ɃZbgl)
#define RS_HARDWARE_PACK		0x00	// ꊇs(_RS_HARDWARE_INFO  DeviceMode ɃZbgl)
#define RS_HARDWARE_SEQ			0x02	// s(_RS_HARDWARE_INFO  DeviceMode ɃZbgl)
#define RS_HARDWARE_OFF			0x00	// dsȂ(_RS_HARDWARE_INFO  PowerCtrl ɃZbgl)
#define RS_HARDWARE_ON			0x01	// ds(_RS_HARDWARE_INFO  PowerCtrl ɃZbgl)
#define RS_HARDWARE_1_8V		0x02	// o͓d 1.8V(_RS_HARDWARE_INFO  PowerCtrl ɃZbgl)
#define RS_HARDWARE_2_5V		0x04	// o͓d 2.5V(_RS_HARDWARE_INFO  PowerCtrl ɃZbgl)
#define RS_HARDWARE_3_3V		0x06	// o͓d 3.3V(_RS_HARDWARE_INFO  PowerCtrl ɃZbgl)
#define RS_HARDWARE_5_0V		0x08	// o͓d 5.0V(_RS_HARDWARE_INFO  PowerCtrl ɃZbgl)

// I2CvAbvݒ (usb61mk2_i2c_pullup Ŏw肷)
#define RS_I2C_PULLUP_DISABL	0x00	// SCL, SDA s̃vAbvsȂ
#define RS_I2C_PULLUP_ENABLE	0x01	// SCL, SDA s̃vAbvs

//
// I2C Acknowledge
//
// I2C Acknowledge  (_RS_I2C_ACKNOWLEDGE_INFO \)
typedef struct _RS_I2C_ACKNOWLEDGE_INFO {
	UCHAR Status;	// Xe[^X 0:ACKMŏI  1:WriteCycleԖŏI
	USHORT	DeviceAddress;	// foCXAhX
	UCHAR	Addr10;			// I2C foCX10 rbgAhXł邩w肷
	ULONG	WriteCycle;		// ACK PollingsԂ~bPʂŎw肷
	USHORT	Polling;		// ACK PollingsԊu}CNbPʂŎwŒZ͖10)
	UCHAR	REG;			// Acknowledge Polling ̐퓮쎞̌ʂi[郌WX^ԍ
} RS_I2C_ACKNOWLEDGE_INFO, *PRS_I2C_ACKNOWLEDGE_INFO;

//
// I2C Master infomation
//
// I2C Master Read (_RS_I2C_MASTER_INFO \)
typedef struct _RS_I2C_MASTER_INFO {
	USHORT	DeviceAddress;	// foCXAhX
	UCHAR	Addr10;			// I2C foCX10 rbgAhXł邩w肷
	UCHAR	StopCondition;	// XgbvRfBV̗Lݒ肷
	UCHAR	Speed;			// ʐMx
	UCHAR	REG;			// f[^l̎Qƌ̎w
	UCHAR	SubAdrsMode;	// TuAhX̑Mw肷
	UCHAR	Sign;			// g̒l
	UCHAR	Adjust;			// g̒l
	ULONG	SubAddress;		// TuAhX
	ULONG	DataBytes;		// ANZXoCg
	UCHAR*	pDataBuf;		// ANZXf[^
} RS_I2C_MASTER_INFO, *PRS_I2C_MASTER_INFO;
// I2C Master Read (usb61mk2_i2c_read_master Ŏw肷l)
#define RS_I2C_ADDR_7			0x00	// foCX7 rbgAhX (_RS_I2C_MASTER_INFO  Addr10 ɃZbgl)
#define RS_I2C_ADDR_10			0x01	// foCX10 rbgAhX (_RS_I2C_MASTER_INFO  Addr10 ɃZbgl)
#define RS_I2C_STOP_OFF			0x00	// XgbvRfBV𔭍sȂ (_RS_I2C_MASTER_INFO  StopCondition ɃZbgl)
#define RS_I2C_STOP_ON			0x02	// XgbvRfBV𔭍s (_RS_I2C_MASTER_INFO  StopCondition ɃZbgl)
#define RS_I2C_SPEED_FAST		0x00	// Standard/Fast-mode (_RS_I2C_MASTER_INFO  Speed ɃZbgl)
#define RS_I2C_SPEED_HIGH		0x04	// High-Speed (_RS_I2C_MASTER_INFO  Speed ɃZbgl)
#define RS_I2C_SPEED_ULTRA	0x08	// Ultra-Speed (_RS_I2C_MASTER_INFO  Speed ɃZbgl)
#define RS_I2C_REG_LITERAL		0x00	// el(RS_I2C_SEND_INFO  REG ɃZbgl)
#define RS_I2C_REG_REGISTER		0x80	// WX^liDATAn 0`15 ̒lw肷j(RS_I2C_SEND_INFO  REG ɃZbgl)
#define RS_I2C_SUBADRS_NO		0x00	// TuAhX𑗐MȂ(_RS_I2C_MASTER_INFO  SubAdrsMode ɃZbgl)
#define RS_I2C_SUBADRS_0		0x10	// TuAhX0 𑗐M(_RS_I2C_MASTER_INFO  SubAdrsMode ɃZbgl)
#define RS_I2C_SUBADRS_01		0x20	// TuAhX0,1 ̏őM(_RS_I2C_MASTER_INFO  SubAdrsMode ɃZbgl)
#define RS_I2C_SUBADRS_012		0x30	// TuAhX0,1,2 ̏őM(_RS_I2C_MASTER_INFO  SubAdrsMode ɃZbgl)
#define RS_I2C_SUBADRS_0123		0x40	// TuAhX0,1,2,3 ̏őM(_RS_I2C_MASTER_INFO  SubAdrsMode ɃZbgl)

// I2C Send  (_RS_I2C_SEND_INFO \)
typedef struct _RS_I2C_SEND_INFO {
	UCHAR	StopCondition;	// XgbvRfBV̗Lݒ肷
	UCHAR	Speed;			// ʐMx
	UCHAR	IgnoreNack;		// Nack𔭐ĂG[ƂɒʐMp
	UCHAR	REG;			// f[^l̎Qƌ̎w
	UCHAR	Sign;			// g̒l
	UCHAR	Adjust;			// g̒l
	ULONG	DataBytes;		// ANZXoCg
	UCHAR*	pDataBuf;		// ANZXf[^
} RS_I2C_SEND_INFO, *PRS_I2C_SEND_INFO;
// I2C Send  (usb61mk2_i2c_Send Ŏw肷l)
#define RS_I2C_SEND_STOP_OFF		0x00	// XgbvRfBV𔭍sȂ (RS_I2C_SEND_INFO  StopCondition ɃZbgl)
#define RS_I2C_SEND_STOP_ON			0x02	// XgbvRfBV𔭍s (RS_I2C_SEND_INFO  StopCondition ɃZbgl)
#define RS_I2C_SEND_SPEED_FAST		0x00	// Standard/Fast-mode (RS_I2C_SEND_INFO  Speed ɃZbgl)
#define RS_I2C_SEND_SPEED_HIGH		0x04	// High-Speed (RS_I2C_SEND_INFO  Speed ɃZbgl)
#define RS_I2C_SEND_SPEED_ULTRA		0x08	// Ultra Fast-Speed (RS_I2C_SEND_INFO  Speed ɃZbgl)
#define RS_I2C_SEND_REG_LITERAL		0x00	// el(RS_I2C_SEND_INFO  REG ɃZbgl)
#define RS_I2C_SEND_REG_REGISTER		0x80	// WX^liDATAn 0`15 ̒lw肷j(RS_I2C_SEND_INFO  REG ɃZbgl)

//
// I2C Slave infomation
//
// I2C Slave Read (_RS_I2C_SLAVE_INFO \)
typedef struct _RS_I2C_SLAVE_INFO {
	USHORT	DeviceAddress;	// foCXAhX
	UCHAR	Addr10;			// I2C foCX10 rbgAhXł邩w肷
	UCHAR	SubAdrsSize;	// TuAhX̃oCg
	UCHAR	Nack;			// NACK ԂAhX@\w肷
	UCHAR	Clock;			// NbNXgb`sAhX@\w肷
  UCHAR Channel;				// `l
  UCHAR Ring;				// ̈Oobt@Ɏgp
  UCHAR Ringp;				// y[ẄOobt@Ɏgp
  UCHAR EN;				    // w肵`l̐ݒ
	UCHAR	ClockTime;		// NbNXgb`ԁi1`255msj
	UCHAR PageSize;				// y[WTCY
	UCHAR WriteCycle;				// CgTCN
	ULONG	NackAddress;	// NackAhX
	ULONG NackAddressMask;		// NackAhX}XN
	ULONG	ClockAddress;	// Clock StretchAhX
	ULONG ClockAddressMask;	// Clock StretchAhX}XN
	ULONG MemoryAddress;		// AhX
	ULONG MemoryAddressMask;		// AhX}XN
} RS_I2C_SLAVE_INFO, *PRS_I2C_SLAVE_INFO;
// I2C Slave Read (usb61mk2_i2c_slave_start Ŏw肷l)
#define RS_I2C_SUBADRS_SIZE_0	0x00	// 0oCg(_RS_I2C_SLAVE_INFO  SubAdrsSize ɃZbgl)
#define RS_I2C_SUBADRS_SIZE_1	0x02	// 1oCg(_RS_I2C_SLAVE_INFO  SubAdrsSize ɃZbgl)
#define RS_I2C_SUBADRS_SIZE_2	0x04	// 2oCg(_RS_I2C_SLAVE_INFO  SubAdrsSize ɃZbgl)
#define RS_I2C_SUBADRS_SIZE_3	0x06	// 3oCg(_RS_I2C_SLAVE_INFO  SubAdrsSize ɃZbgl)
#define RS_I2C_SUBADRS_SIZE_4	0x08	// 4oCg(_RS_I2C_SLAVE_INFO  SubAdrsSize ɃZbgl)
#define RS_I2C_NACK_OFF			0x00	// NACK ԂAhX@\Ȃ (_RS_I2C_SLAVE_INFO  Nack ɃZbgl)
#define RS_I2C_NACK_ON			0x10	// NACK ԂAhX@\ (_RS_I2C_SLAVE_INFO  Nack ɃZbgl)
#define RS_I2C_CLOCK_OFF		0x00	// NbNXgb`sAhX@\Ȃ (_RS_I2C_SLAVE_INFO  Clock ɃZbgl)
#define RS_I2C_CLOCK_ON			0x20	// NbNXgb`sAhX@\ (_RS_I2C_SLAVE_INFO  Clock ɃZbgl)
#define RS_I2C_RINGP_OFF		0x00	// y[ẄOobt@(_RS_I2C_SLAVE_INFO  Ring ɃZbgl)
#define RS_I2C_RINGP_ON			0x20	// y[ẄOobt@L(_RS_I2C_SLAVE_INFO  Ring ɃZbgl)
#define RS_I2C_RING_OFF			0x00	// ̈Oobt@(_RS_I2C_SLAVE_INFO  RingP ɃZbgl)
#define RS_I2C_RING_ON			0x40	// ̈Oobt@L(_RS_I2C_SLAVE_INFO  RingP ɃZbgl)
#define RS_I2C_EN_OFF			0x00	// w`l(_RS_I2C_SLAVE_INFO  EN ɃZbgl)
#define RS_I2C_EN_ON			0x80	// w`lL(_RS_I2C_SLAVE_INFO  EN ɃZbgl)

											   
//
// SPI infomation
//
// SPI (_RS_SPI_INFO \)
typedef struct _RS_SPI_INFO {
	UCHAR	SampTiming;		// TvO^C~O̐ݒ
	UCHAR	FB;				// f[^I[_[ݒ
	UCHAR	SS_A;				// M_
	UCHAR	SS_Dis;				// ݒ
	LONG	dwSPIFreq;		// ݒg
} RS_SPI_INFO, *PRS_SPI_INFO;
// SPI (usb61mk2_spi_set_freq/usb61mk2_spi_get_freq Ŏw肷l)
#define RS_SPI_MODE0		  0x01	// oXTvO@[h0(_RS_SPI_INFO  SampTiming ɃZbgl)
#define RS_SPI_MODE1		  0x00	// oXTvO@[h1(_RS_SPI_INFO  SampTiming ɃZbgl)
#define RS_SPI_MODE2		  0x03	// oXTvO@[h2(_RS_SPI_INFO  SampTiming ɃZbgl)
#define RS_SPI_MODE3		  0x02	// oXTvO@[h3(_RS_SPI_INFO  SampTiming ɃZbgl)
#define RS_SPI_FB_MSB			0x00	// f[^MSB 瑗M(_RS_SPI_INFO  FB ɃZbgl)
#define RS_SPI_FB_LSB			0x04	// f[^LSB 瑗M(_RS_SPI_INFO  FB ɃZbgl)
#define RS_SPI_SSA_MSB		0x00	// f[^MSB 瑗M(_RS_SPI_INFO  SS_A ɃZbgl)
#define RS_SPI_SSA_LSB		0x10	// f[^LSB 瑗M(_RS_SPI_INFO  SS_A ɃZbgl)
#define RS_SPI_SSDIS_ON		0x00	// f[^MSB 瑗M(_RS_SPI_INFO  SS_Dis ɃZbgl)
#define RS_SPI_SSDIS_OFF	0x20	// f[^LSB 瑗M(_RS_SPI_INFO  SS_Dis ɃZbgl)

// SPI_TRANSFER (_RS_SPI_TRANSFER_INFO \)
typedef struct _RS_SPI_TRANSFER_INFO {
	UCHAR	MultiIO;		// Multi I/O w肷Dw肵ꍇ́CSingle-SPI ƂD
	UCHAR	Read;			// ]f[^ɑ΂Read Data Ԃw肷
	UCHAR	SS;				// X[uZNgpPIN ̐sD]JnOɃZbgiLow Levelj]ɃZbgiHigh LeveljsD
	UCHAR	REG;			// f[^l̎Qƌ̎w
	UCHAR	Transbit;		// 1byte ̓]rbgw肷D0 ̏ꍇ́C8bit ]ɂȂ
	ULONG	WriteBytes;		// ANZXoCg
	ULONG	ReadBytes;		// ANZXoCg
	UCHAR*	pWriteDataBuf;		// ANZXf[^
	UCHAR*	pReadDataBuf;		// ANZXf[^
} RS_SPI_TRANSFER_INFO, *PRS_SPI_TRANSFER_INFO;
// SPI_TRANSFER (usb61mk2_spi_transmit_master Ŏw肷l)
#define RS_SPITRANSFER_MULTI_SINGLE		0x00	// Single-SPI(_RS_SPI_TRANSFER_INFO  MultiIO ɃZbgl)
#define RS_SPITRANSFER_MULTI_DUAL		0x01	// Dual-SPI(_RS_SPI_TRANSFER_INFO  MultiIO ɃZbgl)
#define RS_SPITRANSFER_MULTI_QUAD		0x02	// Quad-SPI(_RS_SPI_TRANSFER_INFO  MultiIO ɃZbgl)
#define RS_SPITRANSFER_MULTI_DISABLE	0x03	// (Single-SPI)(_RS_SPI_TRANSFER_INFO  MultiIO ɃZbgl)
#define RS_SPITRANSFER_READ_ONLY		0x00	// ǂݎ̂Ă(_RS_SPI_TRANSFER_INFO  Read ɃZbgl)
#define RS_SPITRANSFER_READ_RESPONSE	0x10	// X|XɃ[hf[^Ԃ(_RS_SPI_TRANSFER_INFO  Read ɃZbgl)
#define RS_SPITRANSFER_SS_OFF			0x00	// ǂݎ̂Ă(_RS_SPI_TRANSFER_INFO  SS ɃZbgl)
#define RS_SPITRANSFER_SS_ON			0x20	// X|XɃ[hf[^Ԃ(_RS_SPI_TRANSFER_INFO  SS ɃZbgl)
#define RS_SPITRANSFER_REG_LITERAL		0x00	// el(_RS_SPI_TRANSFER_INFO  REG ɃZbgl)
#define RS_SPITRANSFER_REG_REGISTER		0x80	// WX^liDATAn 0`15 ̒lw肷j(_RS_SPI_TRANSFER_INFO  REG ɃZbgl)

//
// SPI Slave infomation
//
// SPI Slave Read (_RS_SPI_SLAVE_INFO \)
typedef struct _RS_SPI_SLAVE_INFO {
	UCHAR Channel;				// `l
	UCHAR Ring;				// ̈Oobt@Ɏgp
	UCHAR Ringp;				// y[ẄOobt@Ɏgp
	UCHAR EN;				    // w肵`l̐ݒ
	UCHAR PageSize;				// y[WTCY
	UCHAR WriteCycle;				// CgTCN
	UCHAR	ReadCode;			// ReadpIyR[hw肷
	UCHAR	WriteCode;			// WritepIyR[hw肷
	UCHAR	WriteEnabelCode;	// Write Enable pIyR[hw肷
	UCHAR	WriteDisabelCode;	// Write Disable pIyR[hw肷
	UCHAR ReadStatusReg;		// Read Status Register pIyR[hw肷
	UCHAR WriteStatusReg;		// Write Status Register pIyR[hw肷
	UCHAR PE;				// Page Erase pIyR[hw肷
	UCHAR CE;				// Chip Erase pIyR[hw肷
	UCHAR DOR;				// Dual Output Read pIyR[hw肷
	UCHAR QOR;				// Quad Output Read pIyR[hw肷
	UCHAR DFOR;				// Dual Fast Output Read pIyR[hw肷
	UCHAR QFOR;				// Quad Fast Output Read pIyR[hw肷
	UCHAR DPP;				// Dual Page Program pIyR[hw肷
	UCHAR QPP;				// Quad Page Program pIyR[hw肷
	UCHAR DFPP;				// Dual Fast Page Program pIyR[hw肷
	UCHAR QFPP;				// Quad Fast Page Program pIyR[hw肷
	UCHAR EraseValue;				// EraseR}hsɏޒl
	UCHAR EraseTime;				// EraseR}hs̏(ms)
	UCHAR DummyCycle;				// _~[TCN

	UCHAR	BitWidth;		// CXgNṼrbg

	UCHAR	SubAdrsSize;	// TuAhX̃oCg
	UCHAR SampTiming;				// TvO^C~O
	UCHAR FB;				// f[^[I[_
	UCHAR SS_A;				// X[uZNg
	UCHAR WIP;				// CgCvZXrbg̃rbg@
	UCHAR WEL;				// CgCl[ub`rbg̃rbg@

	UCHAR	ST;					// Xe[^XWX^bit2-6̐@

	UCHAR WPEN;				// CgveNgCl[ũrbg@
	ULONG MemoryAddress;		// AhX
	ULONG MemoryAddressMask;		// AhX}XN
} RS_SPI_SLAVE_INFO, *PRS_SPI_SLAVE_INFO;
// SPI Slave Read (usb61mk2_spi_slave_start Ŏw肷l)
#define RS_SPISLAVE_SUBADRS_SIZE_1	0x01	// 1oCg(_RS_SPI_SLAVE_INFO  SubAdrsSize ɃZbgl)
#define RS_SPISLAVE_SUBADRS_SIZE_2	0x02	// 2oCg(_RS_SPI_SLAVE_INFO  SubAdrsSize ɃZbgl)
#define RS_SPISLAVE_SUBADRS_SIZE_3	0x03	// 3oCg(_RS_SPI_SLAVE_INFO  SubAdrsSize ɃZbgl)
#define RS_SPISLAVE_SUBADRS_SIZE_4	0x04	// 4oCg(_RS_SPI_SLAVE_INFO  SubAdrsSize ɃZbgl)
#define RS_SPISLAVE_MODE0		0x10	// oXTvO@[h0(_RS_SPI_SLAVE_INFO  SampTiming ɃZbgl)
#define RS_SPISLAVE_MODE1		0x00	// oXTvO@[h1(_RS_SPI_SLAVE_INFO  SampTiming ɃZbgl)
#define RS_SPISLAVE_MODE2		0x30	// oXTvO@[h2(_RS_SPI_SLAVE_INFO  SampTiming ɃZbgl)
#define RS_SPISLAVE_MODE3		0x20	// oXTvO@[h3(_RS_SPI_SLAVE_INFO  SampTiming ɃZbgl)
#define RS_SPISLAVE_FB_MSB		0x00	// f[^MSB瑗M(_RS_SPI_SLAVE_INFO  FB ɃZbgl)
#define RS_SPISLAVE_FB_LSB		0x40	// f[^LSB瑗M(_RS_SPI_SLAVE_INFO  FB ɃZbgl)

#define RS_SPISLAVE_SINGLE		0x00	// CXgNṼrbgSingle(_RS_SPI_SLAVE_INFO  BitWidth ɃZbgl)
#define RS_SPISLAVE_DUAL		  0x40	// CXgNṼrbgDual(_RS_SPI_SLAVE_INFO  BitWidth ɃZbgl)
#define RS_SPISLAVE_QUAD		  0x80	// CXgNṼrbgQuad(_RS_SPI_SLAVE_INFO  BitWidth ɃZbgl)
#define RS_SPISLAVE_SINGLE2		0xC0	// CXgNṼrbgSingle(_RS_SPI_SLAVE_INFO  BitWidth ɃZbgl)

#define RS_SPISLAVE_SSA_OFF		0x00	// X[uZNg ANeBuLow(_RS_SPI_SLAVE_INFO  SS_A ɃZbgl)
#define RS_SPISLAVE_SSA_ON		0x80	// X[uZNg ANeBuHigh(_RS_SPI_SLAVE_INFO  SS_A ɃZbgl)
#define RS_SPISLAVE_WIP_OFF		0x00	// 䖳(_RS_SPI_SLAVE_INFO  WIP ɃZbgl)
#define RS_SPISLAVE_WIP_ON		0x01	// L(_RS_SPI_SLAVE_INFO  WIP ɃZbgl)
#define RS_SPISLAVE_WEL_OFF		0x00	// 䖳(_RS_SPI_SLAVE_INFO  WEL ɃZbgl)

#define RS_SPISLAVE_ST_OFF		0x00	// 䖳(_RS_SPI_SLAVE_INFO  ST ɃZbgl)
#define RS_SPISLAVE_ST_ON     0x04	// L(_RS_SPI_SLAVE_INFO  ST ɃZbgl)

#define RS_SPISLAVE_WEL_ON		0x02	// L(_RS_SPI_SLAVE_INFO  WEL ɃZbgl)
#define RS_SPISLAVE_WPEN_OFF	0x00	// 䖳(_RS_SPI_SLAVE_INFO  WPEN ɃZbgl)
#define RS_SPISLAVE_WPEN_ON		0x80	// L(_RS_SPI_SLAVE_INFO  WPEN ɃZbgl)
#define RS_SPISLAVE_RING_OFF		0x00	// ̈Oobt@(_RS_SPI_SLAVE_INFO  Ring ɃZbgl)
#define RS_SPISLAVE_RING_ON		0x40	// ̈Oobt@L(_RS_SPI_SLAVE_INFO  Ring ɃZbgl)
#define RS_SPISLAVE_RINGP_OFF		0x00	// y[ẄOobt@(_RS_SPI_SLAVE_INFO  Ringp ɃZbgl)
#define RS_SPISLAVE_RINGP_ON		0x20	// y[ẄOobt@L(_RS_SPI_SLAVE_INFO  Ringp ɃZbgl)
#define RS_SPISLAVE_EN_OFF		0x00    // w`l(_RS_SPI_SLAVE_INFO  EN ɃZbgl)
#define RS_SPISLAVE_EN_ON		0x80	// w`lL(_RS_SPI_SLAVE_INFO  EN ɃZbgl)

//
// Register infomation
//
// Register (_RS_REG_INFO \)
typedef struct _RS_REG_INFO {
	UCHAR	RegNo;			// gp郌WX^ԍDi0`15j
	UCHAR	Tx;				// Qƌ̑Iw肷
	WORD	Param;			// Qƌɒlݒ肷( DIO:0x0000  ReadData:oCg  LITERAL:0x0000-0x00FF )
} RS_REG_INFO, *PRS_REG_INFO;
// Register (usb61mk2_set_reg/usb61mk2_get_reg Ŏw肷l)
#define RS_REG_TX_DIO		0x00	// DIO(_RS_REG_INFO  Tx ɃZbgl)
#define RS_REG_TX_READ		0x01	// ReadData(_RS_REG_INFO  Tx ɃZbgl)
#define RS_REG_TX_LITERAL	0x02	// LITERAL(_RS_REG_INFO  Tx ɃZbgl)
#define RS_REG_TX_DISABLE	0x03	// Disable(_RS_REG_INFO  Tx ɃZbgl)

//
// Xe[^XR[h
//
#define RS_SUCCESS						 0
#define RS_OTHER_ERROR					-1
#define RS_INIT_ERROR					-2
#define RS_CONTROL_ERROR				-3
#define RS_WRITE_ERROR					-4
#define RS_READ_ERROR					-5
#define RS_INT_ERROR					-6
#define RS_OUT_OF_RANGE					-7
#define RS_TIMEOUT_ERROR					-8

//
// API ֐`
//

#define USB61MK2LIB_API __declspec(dllimport)
#pragma comment(lib, "REXUSB61MK2x64")

#ifdef __cplusplus
extern "C" {
#endif

USB61MK2LIB_API INT APIENTRY RsControlTransfer( UCHAR UnitID, UCHAR bRequestType, UCHAR bRequest, USHORT wValue, USHORT wIndex, USHORT DataLength, PUCHAR pData );
USB61MK2LIB_API INT APIENTRY RsBulkTransfer( UCHAR UnitID, PUCHAR pSendData, ULONG SendLength, PUCHAR pRecvData, ULONG RecvLength );
USB61MK2LIB_API INT APIENTRY RsBulkOutCancel( UCHAR UnitID );
USB61MK2LIB_API INT APIENTRY RsBulkInCancel( UCHAR UnitID );
USB61MK2LIB_API INT APIENTRY RsInterruptTransfer( UCHAR UnitID, PUCHAR pRecvData, ULONG RecvLength );
USB61MK2LIB_API INT APIENTRY RsInterruptTransferTimeOut( UCHAR UnitID, PUCHAR pRecvData, ULONG RecvLength, ULONG mSec );
USB61MK2LIB_API INT APIENTRY RsInterruptCancel( UCHAR UnitID );
USB61MK2LIB_API INT APIENTRY RsSpti_ExecDataIn( UCHAR UnitID, BYTE *CdbData, BYTE CdbLength, BYTE *buffer, DWORD *pDataLength );

USB61MK2LIB_API INT APIENTRY RsDFUControlTransfer( UCHAR UnitID, UCHAR bRequestType, UCHAR bRequest, USHORT wValue, USHORT wIndex, USHORT DataLength, PUCHAR pData );
USB61MK2LIB_API INT APIENTRY RsDFUBusReset( UCHAR UnitID );


USB61MK2LIB_API INT APIENTRY usb61mk2_init( HWND hwnd );
USB61MK2LIB_API INT APIENTRY usb61mk2_start_interrupt( UCHAR UnitID );
USB61MK2LIB_API INT APIENTRY usb61mk2_stop_interrupt( UCHAR UnitID );

// general function
USB61MK2LIB_API INT APIENTRY usb61mk2_reset( UCHAR UnitID );
USB61MK2LIB_API INT APIENTRY usb61mk2_get_fw_version( UCHAR UnitID, UCHAR* pFWMajorVer, UCHAR* pFWMinorVer, UCHAR* pFPGAMajorVer, UCHAR* pFPGAMinorVer );
USB61MK2LIB_API INT APIENTRY usb61mk2_led_control( UCHAR UnitID, UINT fLedState );
USB61MK2LIB_API INT APIENTRY usb61mk2_power_control( UCHAR UnitID, UINT fPowerState );
USB61MK2LIB_API INT APIENTRY usb61mk2_mode_change( UCHAR UnitID, UINT fDeviceMode );
USB61MK2LIB_API INT APIENTRY usb61mk2_set_interval( UCHAR UnitID, USHORT IntervalCnt );
USB61MK2LIB_API INT APIENTRY usb61mk2_get_hw_info( UCHAR UnitID, PRS_HARDWARE_INFO pHardwareInfo );
USB61MK2LIB_API INT APIENTRY usb61mk2_cmd_end( UCHAR UnitID );
USB61MK2LIB_API INT APIENTRY usb61mk2_cmd_pause( UCHAR UnitID );

// dio function
USB61MK2LIB_API INT APIENTRY usb61mk2_set_dio_mode( UCHAR UnitID, UCHAR bDir, UCHAR bInt, UCHAR bPol, UCHAR bTrg );
USB61MK2LIB_API INT APIENTRY usb61mk2_get_dio_mode( UCHAR UnitID, UCHAR* pDir, UCHAR* pInt, UCHAR* pPol, UCHAR* pTrg );
USB61MK2LIB_API INT APIENTRY usb61mk2_set_dio( UCHAR UnitID, UCHAR bData );
USB61MK2LIB_API INT APIENTRY usb61mk2_get_dio( UCHAR UnitID, UCHAR* pData );
USB61MK2LIB_API INT APIENTRY usb61mk2_set_dio_chattering( UCHAR UnitID, SHORT wTime );
USB61MK2LIB_API INT APIENTRY usb61mk2_get_dio_chattering( UCHAR UnitID, SHORT* pTime );

// i2c function
USB61MK2LIB_API INT APIENTRY usb61mk2_i2c_pullup( UCHAR UnitID, UCHAR fI2cPullup );
USB61MK2LIB_API INT APIENTRY usb61mk2_i2c_bus_reset( UCHAR UnitID );
USB61MK2LIB_API INT APIENTRY usb61mk2_i2c_set_freq( UCHAR UnitID, LONG dwI2cFreq );
USB61MK2LIB_API INT APIENTRY usb61mk2_i2c_get_freq_ex( UCHAR UnitID, LONG* pI2cFreq, LONG* pI2cApproFreq );
USB61MK2LIB_API INT APIENTRY usb61mk2_i2c_read_master( UCHAR UnitID, RS_I2C_MASTER_INFO* pI2CMasterInfo );
USB61MK2LIB_API INT APIENTRY usb61mk2_i2c_write_master( UCHAR UnitID, RS_I2C_MASTER_INFO* pI2CMasterInfo );
USB61MK2LIB_API INT APIENTRY usb61mk2_i2c_send( UCHAR UnitID, RS_I2C_SEND_INFO* pI2CSendInfo );
USB61MK2LIB_API INT APIENTRY usb61mk2_i2c_reset_device( UCHAR UnitID, UCHAR mode );
USB61MK2LIB_API INT APIENTRY usb61mk2_i2c_acknowledge( UCHAR UnitID, RS_I2C_ACKNOWLEDGE_INFO* pI2CAcknowledgeInfo );
USB61MK2LIB_API INT APIENTRY usb61mk2_i2c_master_acknowledge( UCHAR UnitID, RS_I2C_ACKNOWLEDGE_INFO* pI2CAcknowledgeInfo );
USB61MK2LIB_API INT APIENTRY usb61mk2_i2c_slave_start( UCHAR UnitID );
USB61MK2LIB_API INT APIENTRY usb61mk2_i2c_slave_end( UCHAR UnitID );
USB61MK2LIB_API INT APIENTRY usb61mk2_i2c_read_slave_config( UCHAR UnitID, UCHAR Channel, RS_I2C_SLAVE_INFO* pI2CSlaveInfo );
USB61MK2LIB_API INT APIENTRY usb61mk2_i2c_write_slave_config( UCHAR UnitID, UCHAR Channel, RS_I2C_SLAVE_INFO* pI2CSlaveInfo );
USB61MK2LIB_API INT APIENTRY usb61mk2_i2c_read_master_config( UCHAR UnitID, RS_I2C_MASTER_INFO* pI2CMasterInfo );
USB61MK2LIB_API INT APIENTRY usb61mk2_i2c_write_master_config( UCHAR UnitID, UCHAR fDevAdrs, UCHAR fAdrs10, UCHAR fSpeed, RS_I2C_MASTER_INFO* pI2CMasterInfo );
USB61MK2LIB_API INT APIENTRY usb61mk2_i2c_read_master_data( UCHAR UnitID, RS_I2C_MASTER_INFO* pI2CMasterInfo );
USB61MK2LIB_API INT APIENTRY usb61mk2_i2c_write_master_data( UCHAR UnitID, RS_I2C_MASTER_INFO* pI2CMasterInfo );
USB61MK2LIB_API INT APIENTRY usb61mk2_i2c_read_slave_data( UCHAR UnitID, UCHAR Channel, USHORT Offset, USHORT DataLength, UCHAR *pData );
USB61MK2LIB_API INT APIENTRY usb61mk2_i2c_write_slave_data( UCHAR UnitID, UCHAR Channel, USHORT Offset, USHORT DataLength, UCHAR *pData );
USB61MK2LIB_API INT APIENTRY usb61mk2_spi_read_slave_status( UCHAR UnitID, UCHAR* pInst0, UCHAR* pReg0, UCHAR* pInst1, UCHAR* pReg1 );
USB61MK2LIB_API INT APIENTRY usb61mk2_spi_write_slave_status( UCHAR UnitID, UCHAR Enable0, UCHAR Reg0, UCHAR Enable1, UCHAR Reg1 );

// spi function
USB61MK2LIB_API INT APIENTRY usb61mk2_spi_set_freq( UCHAR UnitID, PRS_SPI_INFO pSPIInfo );
USB61MK2LIB_API INT APIENTRY usb61mk2_spi_get_freq( UCHAR UnitID, PRS_SPI_INFO pSPIInfo );
USB61MK2LIB_API INT APIENTRY usb61mk2_spi_get_freq_ex( UCHAR UnitID, LONG* pSpiFreq, LONG* pSpiApproFreq );
USB61MK2LIB_API INT APIENTRY usb61mk2_spi_transmit_master( UCHAR UnitID, PRS_SPI_TRANSFER_INFO pSPITransferInfo );
USB61MK2LIB_API INT APIENTRY usb61mk2_spi_read_master_config( UCHAR UnitID, PRS_SPI_TRANSFER_INFO pSPITransferInfo );
USB61MK2LIB_API INT APIENTRY usb61mk2_spi_write_master_config( UCHAR UnitID, UCHAR fMulti, UCHAR fTransbit, PRS_SPI_TRANSFER_INFO pSPITransferInfo );
USB61MK2LIB_API INT APIENTRY usb61mk2_spi_transmit( UCHAR UnitID, PRS_SPI_TRANSFER_INFO pSPITransferInfo );
USB61MK2LIB_API INT APIENTRY usb61mk2_spi_transmit_master_fast( UCHAR UnitID, PRS_SPI_TRANSFER_INFO pWRENInfo, PRS_SPI_TRANSFER_INFO pSPITransferInfo, BYTE RDSR, BYTE bit, BYTE Value, DWORD dwTime );
USB61MK2LIB_API INT APIENTRY usb61mk2_spi_transmit_master_quad_fast( UCHAR UnitID, PRS_SPI_TRANSFER_INFO pWRENInfo, PRS_SPI_TRANSFER_INFO pSPITransferInfo, BYTE RDSR, BYTE bit, BYTE Value, DWORD dwTime );

USB61MK2LIB_API INT APIENTRY usb61mk2_spi_slave_start( UCHAR UnitID );
USB61MK2LIB_API INT APIENTRY usb61mk2_spi_slave_end( UCHAR UnitID );
USB61MK2LIB_API INT APIENTRY usb61mk2_spi_read_slave_config( UCHAR UnitID, UCHAR Channel, RS_SPI_SLAVE_INFO* pSPISlaveInfo );
USB61MK2LIB_API INT APIENTRY usb61mk2_spi_write_slave_config( UCHAR UnitID, UCHAR Channel, RS_SPI_SLAVE_INFO* pSPISlaveInfo );
USB61MK2LIB_API INT APIENTRY usb61mk2_spi_read_slave_data( UCHAR UnitID, UCHAR Channel, USHORT Offset, USHORT DataLength, UCHAR *pData );
USB61MK2LIB_API INT APIENTRY usb61mk2_spi_write_slave_data( UCHAR UnitID, UCHAR Channel, USHORT Offset, USHORT DataLength, UCHAR *pData );
USB61MK2LIB_API INT APIENTRY usb61mk2_spi_get_slave_select( UCHAR UnitID, UCHAR* pMode, UCHAR *pState );
USB61MK2LIB_API INT APIENTRY usb61mk2_spi_set_slave_select( UCHAR UnitID, UCHAR bMode, UCHAR bState );

// script function
USB61MK2LIB_API INT APIENTRY usb61mk2_set_reg( UCHAR UnitID, PRS_REG_INFO pRegInfo );
USB61MK2LIB_API INT APIENTRY usb61mk2_get_reg( UCHAR UnitID, PRS_REG_INFO pRegInfo );
USB61MK2LIB_API INT APIENTRY usb61mk2_wait_process( UCHAR UnitID, WORD wTime );
USB61MK2LIB_API INT APIENTRY usb61mk2_wait_interrupt( UCHAR UnitID, WORD wTime );
USB61MK2LIB_API INT APIENTRY usb61mk2_wait_readstatus( UCHAR UnitID, BYTE RDSR, BYTE bit, BYTE Value, DWORD dwTime );

// set function
USB61MK2LIB_API INT APIENTRY usb61mk2_reset_code( UCHAR UnitID, ULONG WaitTime );
USB61MK2LIB_API INT APIENTRY usb61mk2_execute_code( UCHAR UnitID, PUCHAR pData );
USB61MK2LIB_API INT APIENTRY usb61mk2_get_reset_status( UCHAR UnitID, UCHAR *pStatus );
USB61MK2LIB_API INT APIENTRY usb61mk2_set_mode( UCHAR UnitID, UCHAR fmode );

// get function
USB61MK2LIB_API INT APIENTRY usb61mk2_get_state_device( UCHAR UnitID, UCHAR *pData );
USB61MK2LIB_API INT APIENTRY usb61mk2_get_buffer_size( UCHAR UnitID, UCHAR *pData );
USB61MK2LIB_API INT APIENTRY usb61mk2_get_regist_value( UCHAR UnitID, UCHAR *pData );
USB61MK2LIB_API INT APIENTRY usb61mk2_get_state_hw( UCHAR UnitID, UCHAR *pData );
USB61MK2LIB_API INT APIENTRY usb61mk2_get_version_fw( UCHAR UnitID, UCHAR *pData );
USB61MK2LIB_API INT APIENTRY usb61mk2_get_over_tick( UCHAR UnitID, UCHAR *pData );

// debug function
USB61MK2LIB_API INT APIENTRY usb61mk2_read_eeprom( UCHAR UnitID, WORD Address, WORD DataLength, UCHAR *pData );
USB61MK2LIB_API INT APIENTRY usb61mk2_write_eeprom( UCHAR UnitID, WORD Address, WORD DataLength, UCHAR *pData );
USB61MK2LIB_API INT APIENTRY usb61mk2_read_cpu_memory( UCHAR UnitID, ULONG Address, WORD DataLength, UCHAR *pData );
USB61MK2LIB_API INT APIENTRY usb61mk2_write_cpu_memory( UCHAR UnitID, ULONG Address, WORD DataLength, UCHAR* pdwData );
USB61MK2LIB_API INT APIENTRY usb61mk2_read_pld( UCHAR UnitID, WORD Address, WORD DataLength, UCHAR *pData );
USB61MK2LIB_API INT APIENTRY usb61mk2_write_pld( UCHAR UnitID, WORD Address, WORD DataLength, UCHAR *pData );


USB61MK2LIB_API INT APIENTRY usb61mk2_get_serial( UCHAR UnitID, WORD DataLength,UCHAR *pData );
USB61MK2LIB_API INT APIENTRY usb61mk2_lock( UCHAR UnitID );
USB61MK2LIB_API INT APIENTRY usb61mk2_unlock( UCHAR UnitID );


#ifdef __cplusplus
}
#endif


#endif /* __USB61M_DEFINE__ */